#include "lasp_deviceinfo.h"
#include <algorithm>
#include <cassert>

#define MAX_DEV_COUNT_PER_API 20

#if LASP_HAS_ULDAQ == 1
#include "lasp_uldaq.h"
#endif
#if LASP_HAS_RTAUDIO == 1
#include "lasp_rtaudiodaq.h"
#endif


std::vector<DeviceInfo> DeviceInfo::getDeviceInfo() {
  std::vector<DeviceInfo> devs;
#if LASP_HAS_ULDAQ ==1
  fillUlDaqDeviceInfo(devs);
#endif

#if LASP_HAS_RTAUDIO == 1
  fillRtAudioDeviceInfo(devs);
#endif

  return devs;
}

