/* #define DEBUGTRACE_ENABLED */
#include "lasp_thread.h"
#include "BS_thread_pool.hpp"
#include "debugtrace.hpp"
#include <memory>

/**
 * @brief It seems to work much better in cooperation with Pybind11 when this
 * singleton is implemented with a unique_ptr.
 */
std::unique_ptr<BS::thread_pool> _static_storage_threadpool;

void destroyThreadPool() {
  DEBUGTRACE_ENTER;
  _static_storage_threadpool = nullptr;
}

BS::thread_pool &getPool() {
  /* DEBUGTRACE_ENTER; */
  if (!_static_storage_threadpool) {
    DEBUGTRACE_PRINT("Creating new thread pool");
    _static_storage_threadpool = std::make_unique<BS::thread_pool>();
  }
  return *_static_storage_threadpool;
}
