#pragma once
#include "BS_thread_pool.hpp"

/**
 * @brief Return reference to global (singleton) thread pool. The threadpool is
 * created using the default argument, which results in exactly
 * hardware_concurrency() amount of threads.
 *
 * @return Thread pool ref.
 */
BS::thread_pool& getPool();


/**
 * @brief The global thread pool is stored in a unique_ptr, so in normal C++
 * code the thread pool is deleted at the end of main(). However this does not
 * hold when LASP code is run
 */
void destroyThreadPool();
